package logic

import (
	"context"

	"juwan-backend/app/order/rpc/internal/models/orders"
	"juwan-backend/app/order/rpc/internal/svc"
	"juwan-backend/app/order/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetOrdersByIdLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetOrdersByIdLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetOrdersByIdLogic {
	return &GetOrdersByIdLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetOrdersByIdLogic) GetOrdersById(in *pb.GetOrdersByIdReq) (*pb.GetOrdersByIdResp, error) {
	item, err := l.svcCtx.OrderModelsRO.Orders.Query().Where(orders.IDEQ(in.Id)).First(l.ctx)
	if err != nil {
		return nil, err
	}

	return &pb.GetOrdersByIdResp{Orders: toPBOrder(item)}, nil
}
